function [best,bestE,grap]=GA(M,loss,Pelit,Pmut,maxI)
PopSize=size(M,1);
error=ones(PopSize,1);
M=[M error];
for i=1:PopSize 
    M(i,end)=loss(M(i,1:end-1));
end
M=sortrows(M,-1*size(M,2));
best=M(1,1:end-1);
bestE=M(1,end);

for inter=1:maxI
    
    NewM=zeros(size(M));
    Apop=round(size(M,1)*Pelit);
    if rem(size(M,1)-Apop,2)==1
        Apop=Apop-1;
        if Apop==0
            Apop=2;
        end
    end
    NewM(1:Apop,:)=M(1:Apop,:);
    for i=Apop+1:2:size(M,1)
        prog1=TournamentSelection(M(1:Apop,end),3);
        prog2=TournamentSelection(M(1:Apop,end),3);
        
        NC=size(M,2)-1;
        mask=round(rand(1,NC));
        son=zeros(2,NC);
        for j=1:NC
            if mask(j)==1
                son(1,j)=M(prog1,j);
                son(2,j)=M(prog2,j);
            else
                son(1,j)=M(prog2,j);
                son(2,j)=M(prog1,j);
            end
        end
        
        for j=1:2
            p=rand();
            if p<Pmut
                p1=randi(NC);
                son(j,p1)=rand();
                acrom=2*rand(1,NC)-1;
                crom=rand()*(acrom.*son(j,:));
                son(j,:)=rem(son(j,:)+crom,1);
            end
            
            NewM(i+(j-1),end)=loss(son(j,:));
            
            
            NewM(i+(j-1),1:end-1)=son(j,:);
            
        end
        
    end
    M=NewM;
    
    M=sortrows(M,size(M,2));
    if(sum(M(1,1:end-1) == best)~=(size(M,2)-1))
        best=M(1,1:end-1);
        bestE=M(1,end);
    end
    grap(inter)=bestE;
    
end



function A=TournamentSelection(erro,N)
ind=randi(length(erro),N,1);
a=[ind erro(ind)];
a=sortrows(a,2);
A=a(1,1);
